Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTetrahedronShape.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTetrahedronShape.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTetrahedronShape.h	(revision 2430)
@@ -28,13 +28,13 @@
 
 	int	m_numVertices;
-	btPoint3	m_vertices[4];
+	btVector3	m_vertices[4];
 
 public:
 	btBU_Simplex1to4();
 
-	btBU_Simplex1to4(const btPoint3& pt0);
-	btBU_Simplex1to4(const btPoint3& pt0,const btPoint3& pt1);
-	btBU_Simplex1to4(const btPoint3& pt0,const btPoint3& pt1,const btPoint3& pt2);
-	btBU_Simplex1to4(const btPoint3& pt0,const btPoint3& pt1,const btPoint3& pt2,const btPoint3& pt3);
+	btBU_Simplex1to4(const btVector3& pt0);
+	btBU_Simplex1to4(const btVector3& pt0,const btVector3& pt1);
+	btBU_Simplex1to4(const btVector3& pt0,const btVector3& pt1,const btVector3& pt2);
+	btBU_Simplex1to4(const btVector3& pt0,const btVector3& pt1,const btVector3& pt2,const btVector3& pt3);
 
     
@@ -46,5 +46,5 @@
 
 
-	void addVertex(const btPoint3& pt);
+	void addVertex(const btVector3& pt);
 
 	//PolyhedralConvexShape interface
@@ -54,15 +54,15 @@
 	virtual int getNumEdges() const;
 
-	virtual void getEdge(int i,btPoint3& pa,btPoint3& pb) const;
+	virtual void getEdge(int i,btVector3& pa,btVector3& pb) const;
 	
-	virtual void getVertex(int i,btPoint3& vtx) const;
+	virtual void getVertex(int i,btVector3& vtx) const;
 
 	virtual int	getNumPlanes() const;
 
-	virtual void getPlane(btVector3& planeNormal,btPoint3& planeSupport,int i) const;
+	virtual void getPlane(btVector3& planeNormal,btVector3& planeSupport,int i) const;
 
 	virtual int getIndex(int i) const;
 
-	virtual	bool isInside(const btPoint3& pt,btScalar tolerance) const;
+	virtual	bool isInside(const btVector3& pt,btScalar tolerance) const;
 
 
Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleBuffer.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleBuffer.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleBuffer.h	(revision 2430)
@@ -29,5 +29,5 @@
 };
 
-///btTriangleBuffer can be useful to collect and store overlapping triangles between AABB and concave objects that support 'processAllTriangles'
+///The btTriangleBuffer callback can be useful to collect and store overlapping triangles between AABB and concave objects that support 'processAllTriangles'
 ///Example usage of this class:
 ///			btTriangleBuffer	triBuf;
Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp	(revision 2430)
@@ -75,15 +75,19 @@
 }
 
-int	btTriangleMesh::findOrAddVertex(const btVector3& vertex)
+
+int	btTriangleMesh::findOrAddVertex(const btVector3& vertex, bool removeDuplicateVertices)
 {
 	//return index of new/existing vertex
-	//todo: could use acceleration structure for this
+	///@todo: could use acceleration structure for this
 	if (m_use4componentVertices)
 	{
-		for (int i=0;i< m_4componentVertices.size();i++)
-		{
-			if ((m_4componentVertices[i]-vertex).length2() <= m_weldingThreshold)
+		if (removeDuplicateVertices)
 			{
-				return i;
+			for (int i=0;i< m_4componentVertices.size();i++)
+			{
+				if ((m_4componentVertices[i]-vertex).length2() <= m_weldingThreshold)
+				{
+					return i;
+				}
 			}
 		}
@@ -97,12 +101,15 @@
 	{
 		
-		for (int i=0;i< m_3componentVertices.size();i+=3)
+		if (removeDuplicateVertices)
 		{
-			btVector3 vtx(m_3componentVertices[i],m_3componentVertices[i+1],m_3componentVertices[i+2]);
-			if ((vtx-vertex).length2() <= m_weldingThreshold)
+			for (int i=0;i< m_3componentVertices.size();i+=3)
 			{
-				return i/3;
+				btVector3 vtx(m_3componentVertices[i],m_3componentVertices[i+1],m_3componentVertices[i+2]);
+				if ((vtx-vertex).length2() <= m_weldingThreshold)
+				{
+					return i/3;
+				}
 			}
-		}
+	}
 		m_3componentVertices.push_back(vertex.getX());
 		m_3componentVertices.push_back(vertex.getY());
@@ -115,11 +122,10 @@
 }
 		
-void	btTriangleMesh::addTriangle(const btVector3& vertex0,const btVector3& vertex1,const btVector3& vertex2)
+void	btTriangleMesh::addTriangle(const btVector3& vertex0,const btVector3& vertex1,const btVector3& vertex2,bool removeDuplicateVertices)
 {
 	m_indexedMeshes[0].m_numTriangles++;
-		
-	addIndex(findOrAddVertex(vertex0));
-	addIndex(findOrAddVertex(vertex1));
-	addIndex(findOrAddVertex(vertex2));
+	addIndex(findOrAddVertex(vertex0,removeDuplicateVertices));
+	addIndex(findOrAddVertex(vertex1,removeDuplicateVertices));
+	addIndex(findOrAddVertex(vertex2,removeDuplicateVertices));
 }
 
Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.h	(revision 2430)
@@ -26,5 +26,4 @@
 ///If you want to share triangle/index data between graphics mesh and collision mesh (btBvhTriangleMeshShape), you can directly use btTriangleIndexVertexArray or derive your own class from btStridingMeshInterface.
 ///Performance of btTriangleMesh and btTriangleIndexVertexArray used in a btBvhTriangleMeshShape is the same.
-///It has a brute-force option to weld together closeby vertices.
 class btTriangleMesh : public btTriangleIndexVertexArray
 {
@@ -43,5 +42,5 @@
 		btTriangleMesh (bool use32bitIndices=true,bool use4componentVertices=true);
 
-		int		findOrAddVertex(const btVector3& vertex);
+		int		findOrAddVertex(const btVector3& vertex, bool removeDuplicateVertices);
 		void	addIndex(int index);
 
@@ -55,6 +54,7 @@
 			return m_use4componentVertices;
 		}
-		
-		void	addTriangle(const btVector3& vertex0,const btVector3& vertex1,const btVector3& vertex2);
+		///By default addTriangle won't search for duplicate vertices, because the search is very slow for large triangle meshes.
+		///In general it is better to directly use btTriangleIndexVertexArray instead.
+		void	addTriangle(const btVector3& vertex0,const btVector3& vertex1,const btVector3& vertex2, bool removeDuplicateVertices=false);
 		
 		int getNumTriangles() const;
Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp	(revision 2430)
@@ -54,5 +54,5 @@
 	btMatrix3x3 abs_b = trans.getBasis().absolute();  
 
-	btPoint3 center = trans(localCenter);
+	btVector3 center = trans(localCenter);
 
 	btVector3 extent = btVector3(abs_b[0].dot(localHalfExtents),
Index: code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleShape.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleShape.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionShapes/btTriangleShape.h	(revision 2430)
@@ -47,5 +47,5 @@
 	}
 	
-	virtual void getEdge(int i,btPoint3& pa,btPoint3& pb) const
+	virtual void getEdge(int i,btVector3& pa,btVector3& pb) const
 	{
 		getVertex(i,pa);
@@ -89,5 +89,5 @@
 
 
-	virtual void getPlane(btVector3& planeNormal,btPoint3& planeSupport,int i) const
+	virtual void getPlane(btVector3& planeNormal,btVector3& planeSupport,int i) const
 	{
 		getPlaneEquation(i,planeNormal,planeSupport);
@@ -105,5 +105,5 @@
 	}
 
-	virtual void getPlaneEquation(int i, btVector3& planeNormal,btPoint3& planeSupport) const
+	virtual void getPlaneEquation(int i, btVector3& planeNormal,btVector3& planeSupport) const
 	{
 		(void)i;
@@ -119,5 +119,5 @@
 	}
 
-		virtual	bool isInside(const btPoint3& pt,btScalar tolerance) const
+		virtual	bool isInside(const btVector3& pt,btScalar tolerance) const
 	{
 		btVector3 normal;
@@ -133,5 +133,5 @@
 			for (i=0;i<3;i++)
 			{
-				btPoint3 pa,pb;
+				btVector3 pa,pb;
 				getEdge(i,pa,pb);
 				btVector3 edge = pb-pa;
Index: code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btConvexPenetrationDepthSolver.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btConvexPenetrationDepthSolver.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btConvexPenetrationDepthSolver.h	(revision 2430)
@@ -22,5 +22,4 @@
 #include "btSimplexSolverInterface.h"
 class btConvexShape;
-#include "LinearMath/btPoint3.h"
 class btTransform;
 
@@ -34,5 +33,5 @@
 		const btConvexShape* convexA,const btConvexShape* convexB,
 					const btTransform& transA,const btTransform& transB,
-				btVector3& v, btPoint3& pa, btPoint3& pb,
+				btVector3& v, btVector3& pa, btVector3& pb,
 				class btIDebugDraw* debugDraw,btStackAlloc* stackAlloc
 				) = 0;
Index: code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkEpa2.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkEpa2.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkEpa2.cpp	(revision 2430)
@@ -38,5 +38,5 @@
 {
 
-// Config
+	// Config
 
 	/* GJK	*/ 
